//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Laser Boy
//  Copyright (C) 2017 Carlos Sevila (@CarlosSevila)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#ifndef _DEFINES_H_
#define _DEFINES_H_

#define SCR_WIDTH				80
#define SCR_HEIGHT				200

#define COLOR_BLACK				0x00
#define COLOR_BLUE          	0x01
#define COLOR_BRIGHT_BLUE   	0x02
#define COLOR_SKY_BLUE      	0x03
#define COLOR_BRIGHT_CYAN   	0x04
#define COLOR_GRAY   			0x05
#define COLOR_CYAN          	0x06
#define COLOR_BRIGHT_GREEN  	0x07
#define COLOR_SEA_GREEN     	0x08
#define COLOR_RED           	0x09
#define COLOR_BRIGHT_RED    	0x0A
#define COLOR_PURPLE        	0x0B
#define COLOR_PINK          	0x0C
#define COLOR_ORANGE        	0x0D
#define COLOR_BRIGHT_YELLOW 	0x0E
#define COLOR_BRIGHT_WHITE  	0x0F

#define MAP_VOID                COLOR_BLACK
#define MAP_BASIC            	COLOR_BRIGHT_BLUE
#define MAP_LASER     			COLOR_PURPLE
#define MAP_PLAYER_START        COLOR_BRIGHT_WHITE
#define MAP_END					COLOR_BRIGHT_RED
#define MAP_TURRET				COLOR_GRAY
#define MAP_CHASER				COLOR_BRIGHT_YELLOW
#define MAP_DEFORM_BLOCK        COLOR_ORANGE
#define MAP_BREAKABLE_BLOCK     COLOR_RED
#define MAP_INMUNE_CHASER		COLOR_PINK
#define MAP_BOUNCER_X			COLOR_SEA_GREEN
#define MAP_BOUNCER_Y			COLOR_BRIGHT_GREEN
#define MAP_BOUNCER_XY			COLOR_CYAN

#define MAP_WIDTH				20
#define MAP_HEIGHT				12
#define MAP_HALF_WIDTH      	10

#define TILE_WIDTH          	4
#define TILE_HEIGHT         	16
#define HALF_TILE_WIDTH     	2
#define HALF_TILE_HEIGHT    	8
#define QUARTER_TILE_WIDTH  	1
#define QUARTER_TILE_HEIGHT 	4
#define EIGHTH_TILE_HEIGHT  	2
#define DOUBLE_TILE_WIDTH		8
#define DOUBLE_TILE_HEIGHT		32

#define FONT_WIDTH          	2
#define FONT_HEIGHT         	8

#define BIT_1					0x01
#define BIT_2					0x02
#define BIT_3					0x04
#define BIT_4					0x08
#define BIT_5					0x10
#define BIT_6					0x20
#define BIT_7					0x40
#define BIT_8					0x80
#define MAX_U8_VALUE			0xFF

#define JUMP_SIZE				18
#define MAX_SPEED           	12
#define HALF_MAX_SPEED      	6
#define PLAYER_FIRE_RATE    	15
#define PLAYER_MAX_BULLETS  	3
#define PLAYER_BULLET_SPEED 	4

#define MAX_ENEMIES				3
#define ENEMY_TYPE_X			BIT_1
#define ENEMY_TYPE_Y			BIT_2
#define ENEMY_TYPE_BOUNCES		BIT_3
#define ENEMY_TYPE_CHASES		BIT_4
#define ENEMY_TYPE_RESPAWNS		BIT_5
#define ENEMY_TYPE_INVERT		BIT_6
#define ENEMY_TYPE_MAP_INMUNE	BIT_7
#define ENEMY_TYPE_LASER_INMUNE	BIT_8

#define NO_ANIMATION_FRAME_ID	MAX_U8_VALUE

#define COLLISION_TYPE_ENEMY	0
#define COLLISION_TYPE_PLAYER	1
#define COLLISION_TYPE_LASER	2

#define NUM_MAPS            	51

#define DEATH_TIME          	25
#define WIN_TIME            	50

#define MAX_BLOCKS   			32
#define BLOCK_TIME   			90

#define CODE_CHECKPOINT_1		14651
#define CODE_CHECKPOINT_2		25483
#define CODE_CHECKPOINT_3		16321
#define CODE_CHECKPOINT_4		23431
#define CODE_SECRET_MAP			1987

#endif
