//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Laser Boy
//  Copyright (C) 2017 Carlos Sevila (@CarlosSevila)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include "input.h"

Keys keys;

void WaitKeyUp(cpct_keyID key) {
    while (cpct_isKeyPressed(key)) {
        cpct_scanKeyboard_f();
    }
}

// By Rolando.
cpct_keyID WaitForKey() {
    u8 i = 10, *keys = cpct_keyboardStatusBuffer + 9;
    u16 keypressed;

    while (!cpct_isAnyKeyPressed()) {
        cpct_scanKeyboard_f();
    }

    do {
        keypressed = *keys ^ 0xFF;

        if (keypressed) {
            return (keypressed << 8) + (i - 1);
        }

        keys--;
    } while (--i);
}

cpct_keyID RedifineKey() {
    cpct_keyID key;

    key = WaitForKey();
    WaitKeyUp(key);

    return key;
}
