//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Laser Boy
//  Copyright (C) 2017 Carlos Sevila (@CarlosSevila)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include "font.h"

const u8 kLetters[26][16] = {
    // A
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x01
    },
    // B
    {
        0x54, 0xA8, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0xA8, 
        0x01, 0x02, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x02
    },
    // C
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x00, 
        0x54, 0x00, 
        0x01, 0x00, 
        0x01, 0x00, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // D
    {
        0x54, 0xA8, 
        0x54, 0xFC, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x01, 0x02
    },
    // E
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x00, 
        0x54, 0xA8, 
        0x01, 0x02, 
        0x01, 0x00, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // F
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x00, 
        0x54, 0xA8, 
        0x01, 0x02, 
        0x01, 0x00, 
        0x01, 0x00, 
        0x01, 0x00
    },
    // G
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x00, 
        0x54, 0x00, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // H
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0xFC, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x01
    },
    // I
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x00, 0xA8, 
        0x00, 0xA8, 
        0x00, 0x02, 
        0x00, 0x02, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // J
    {
        0x00, 0x54, 
        0x00, 0x54, 
        0x00, 0x54, 
        0x00, 0x54, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // K
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0xFC, 
        0x54, 0xA8, 
        0x01, 0x02, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x01
    },
    // L
    {
        0x54, 0x00, 
        0x54, 0x00, 
        0x54, 0x00, 
        0x54, 0x00, 
        0x01, 0x00, 
        0x01, 0x00, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // M
    {
        0x54, 0x54, 
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x01
    },
    // N
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x01
    },
    // O
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // P
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x00, 
        0x01, 0x00
    },
    // Q
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x02
    },
    // R
    {
        0x54, 0xA8, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0xA8, 
        0x01, 0x02, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x01
    },
    // S
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x54, 0x00, 
        0x54, 0x00, 
        0x01, 0x03, 
        0x00, 0x01, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // T
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x00, 0xA8, 
        0x00, 0xA8, 
        0x00, 0x02, 
        0x00, 0x02, 
        0x00, 0x02, 
        0x00, 0x02
    },
    // U
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x01, 0x03
    },
    // V
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x00, 0x02
    },
    // W
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x01
    },
    // X
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x00, 0xA8, 
        0x00, 0x02, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x01
    },
    // Y
    {
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x54, 
        0x54, 0x56, 
        0x00, 0x02, 
        0x00, 0x02, 
        0x00, 0x02, 
        0x00, 0x02
    },
    // Z
    {
        0x54, 0xFC, 
        0x54, 0xFC, 
        0x00, 0x54, 
        0x00, 0xFC, 
        0x00, 0x02, 
        0x01, 0x00, 
        0x01, 0x03, 
        0x01, 0x03
    }
};

const u8 kNumbers[11][16] = {
    // 0
    {
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x10, 0x10, 
        0x10, 0x10, 
        0x10, 0x30, 
        0x10, 0x30
    },
    // 1
    {
        0x00, 0x02, 
        0x01, 0x02, 
        0x01, 0x02, 
        0x00, 0x02, 
        0x00, 0x20, 
        0x00, 0x20, 
        0x10, 0x30, 
        0x10, 0x30
    },
    // 2
    {
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x00, 0x01, 
        0x00, 0x30, 
        0x10, 0x20, 
        0x10, 0x30, 
        0x10, 0x30
    },
    // 3
    {
        0x01, 0x03, 
        0x01, 0x03, 
        0x00, 0x01, 
        0x00, 0x03, 
        0x00, 0x30, 
        0x00, 0x10, 
        0x10, 0x30, 
        0x10, 0x30
    },
    // 4
    {
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x10, 0x30, 
        0x00, 0x10, 
        0x00, 0x10, 
        0x00, 0x10
    },
    // 5
    {
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x00, 
        0x01, 0x03, 
        0x10, 0x30, 
        0x00, 0x10, 
        0x10, 0x30, 
        0x10, 0x30
    },
    // 6
    {
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x00, 
        0x01, 0x03, 
        0x10, 0x10, 
        0x10, 0x10, 
        0x10, 0x30, 
        0x10, 0x30
    },
    // 7
    {
        0x01, 0x03, 
        0x01, 0x03, 
        0x00, 0x01, 
        0x00, 0x01, 
        0x00, 0x10, 
        0x00, 0x10, 
        0x00, 0x10, 
        0x00, 0x10
    },
    // 8
    {
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x10, 0x30, 
        0x10, 0x10, 
        0x10, 0x10, 
        0x10, 0x30
    },
    // 9
    {
        0x01, 0x03, 
        0x01, 0x03, 
        0x01, 0x01, 
        0x01, 0x03, 
        0x10, 0x30, 
        0x00, 0x10, 
        0x10, 0x30, 
        0x10, 0x30
    },
    // Dots
    {
        0x00, 0x00, 
        0x00, 0x02, 
        0x00, 0x02, 
        0x00, 0x00, 
        0x00, 0x00, 
        0x00, 0x20, 
        0x00, 0x20, 
        0x00, 0x00
    }
};
