//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Laser Boy
//  Copyright (C) 2017 Carlos Sevila (@CarlosSevila)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <cpctelera.h>

#ifndef _SPRITES_H_
#define _SPRITES_H_

// Player
extern const u8 kPlayerIdleRight01[64];
extern const u8 kPlayerIdleRight02[64];
extern const u8 kPlayerIdleLeft01[64];
extern const u8 kPlayerIdleLeft02[64];
extern const u8 kPlayerJumpRight01[64];
extern const u8 kPlayerJumpLeft01[64];
extern const u8 kPlayerFallRight01[64];
extern const u8 kPlayerFallLeft01[64];

// Tiles - Basic
extern const u8 kTileBasicN[64];
extern const u8 kTileBasicE[64];
extern const u8 kTileBasicS[64];
extern const u8 kTileBasicW[64];
extern const u8 kTileBasicNE[64];
extern const u8 kTileBasicES[64];
extern const u8 kTileBasicSW[64];
extern const u8 kTileBasicWN[64];
extern const u8 kTileBasicNES[64];
extern const u8 kTileBasicESW[64];
extern const u8 kTileBasicSWN[64];
extern const u8 kTileBasicWNE[64];
extern const u8 kTileBasicNESW[64];
extern const u8 kTileBasicNS[64];
extern const u8 kTileBasicEW[64];
extern const u8 kTileBasicVoid[64];

// Tiles - Other
extern const u8 kTileLaserN[64];
extern const u8 kTileLaserE[64];
extern const u8 kTileLaserS[64];
extern const u8 kTileLaserW[64];
extern const u8 kTileEnd[64];
extern const u8 kTileDeformBlock01[64];
extern const u8 kTileDeformBlock02[64];
extern const u8 kTileBreakableBlock01[64];
extern const u8 kTileBreakableBlock02[64];

// Enemies
extern const u8 kChaser01[64];
extern const u8 kChaser02[64];
extern const u8 kChaser03[64];
extern const u8 kChaser04[64];
extern const u8 kChaserInmune01[64];
extern const u8 kChaserInmune02[64];
extern const u8 kChaserInmune03[64];
extern const u8 kChaserInmune04[64];
extern const u8 kBouncer01[64];
extern const u8 kBouncer02[64];
extern const u8 kBouncer03[64];
extern const u8 kBouncer04[64];
extern const u8 kTurretN[64];
extern const u8 kTurretE[64];
extern const u8 kTurretS[64];
extern const u8 kTurretW[64];
extern const u8 kAsteroid01[64];
extern const u8 kAsteroid02[64];
extern const u8 kAsteroid03[64];
extern const u8 kAsteroid04[64];

// Death
extern const u8 kDeath01[64];
extern const u8 kDeath02[64];
extern const u8 kDeath03[64];
extern const u8 kDeath04[64];

// Logo
extern const u8 kLaserBoyLogo[3200];

#endif