//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Laser Boy
//  Copyright (C) 2017 Carlos Sevila (@CarlosSevila)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include "util.h"

u8 GetLeftPixelValue(u8 b) {
	u8 result = 0;

	if (b & BIT_2) {
		result |= BIT_4;
	}

	if (b & BIT_4) {
		result |= BIT_2;
	}

	if (b & BIT_6) {
		result |= BIT_3;
	}

	if (b & BIT_8) {
		result |= BIT_1;
	}

	return result;
}

u8 GetRightPixelValue(u8 b) {
	u8 result = 0;

	if (b & BIT_1) {
		result |= BIT_4;
	}

	if (b & BIT_3) {
		result |= BIT_2;
	}

	if (b & BIT_5) {
		result |= BIT_3;
	}

	if (b & BIT_7) {
		result |= BIT_1;
	}

	return result;
}

void DrawTile(u8 *sprite, u8 *memory) {
	cpct_drawTileAligned4x8_f(sprite, memory);
	cpct_drawTileAligned4x8_f(sprite + 32, memory + SCR_WIDTH);
}